package skyland.network;

import io.netty.buffer.ByteBuf;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraftforge.fml.client.FMLClientHandler;
import net.minecraftforge.fml.common.network.ByteBufUtils;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import skyland.client.audio.MovingSoundSkyFalling;
import skyland.handler.SkyEventHooks;

public class FallTeleportMessage implements IMessage, IMessageHandler<FallTeleportMessage, IMessage>
{
	private String uuid;

	public FallTeleportMessage() {}

	public FallTeleportMessage(EntityPlayer player)
	{
		this.uuid = player.getUniqueID().toString();
	}

	@Override
	public void fromBytes(ByteBuf buf)
	{
		uuid = ByteBufUtils.readUTF8String(buf);
	}

	@Override
	public void toBytes(ByteBuf buf)
	{
		ByteBufUtils.writeUTF8String(buf, uuid);
	}

	@SideOnly(Side.CLIENT)
	@Override
	public IMessage onMessage(FallTeleportMessage message, MessageContext ctx)
	{
		SkyEventHooks.fallTeleportPlayers.get().add(message.uuid);

		FMLClientHandler.instance().getClient().getSoundHandler().playSound(new MovingSoundSkyFalling());

		return null;
	}
}